"use strict";

function allCursors(pagedApi) {
  var all = function (options, callback) {
    if (options && !callback) {
      callback = options;
      options = undefined;
    }
    if (options && options.hasOwnProperty("next_cursor") && options.next_cursor === undefined) {
      return callback([]);
    }
    pagedApi(options, function (error, result) {
      if (error) {
        console.error(error);
        callback([]);
      } else {
        all(Object.assign({max_results: 500}, options, {next_cursor: result.next_cursor}), function (resources) {
          callback(result.resources.concat(resources));
        });
      }
    })
  };
  return all;
};


var cloudinary = require('../cloudinary').v2;

var r;
var listAllResources = allCursors(cloudinary.api.resources);
listAllResources(function (resources) {
  console.log("got " + resources.length + " resources");
  r = resources;
});
